package rocks.zipcode.io.quiz4.fundamentals;

import java.util.ArrayList;
import java.util.List;

/**
 * @author leon on 18/12/2018.
 */
public class PalindromeEvaluator {
    public static String[] getAllPalindromes(String string) {
        String[] stringPermutations = StringEvaluator.getAllPrefixes(string);
        ArrayList<String> stringPalindromes = new ArrayList<>();
        for (String s : stringPermutations) {
            if (isPalindrome(s)) {
                stringPalindromes.add(s);
            }
        }
        return stringPalindromes.toArray(new String[0]);
    }

    public static Boolean isPalindrome(String string) {
        return string.equals(reverseString(string));
    }

    public static String reverseString(String string) {
        return new StringBuilder(string).reverse().toString();
    }
}
