package rocks.zipcode.io.quiz4.generics;

import com.google.common.collect.Collections2;
import com.google.common.collect.ImmutableSet;
import com.google.common.collect.Sets;
import rocks.zipcode.io.quiz4.collections.ComparableTreeSet;
import rocks.zipcode.io.quiz4.fundamentals.PalindromeEvaluator;

import java.util.*;

/**
 * @author leon on 11/12/2018.
 */
public class GenericUtils {

    public static <E extends Comparable> Iterable<? extends Iterable<? extends E>> powerSet(TreeSet<? extends E> originalSet) {
////        ArrayList<T> originalList = new ArrayList<>();
////        originalList.addAll(originalSet);
////        ComparableTreeSet<ComparableTreeSet<T>> newSet = new ComparableTreeSet<>();
////        Collection<List<T>> permutations = Collections2.permutations(originalList);
////        for (List<T> list : permutations) {
////            ComparableTreeSet<T> subSet = new ComparableTreeSet<>();
////            subSet.addAll(list);
////            newSet.add(subSet);
////        }
////        for (int i = 0; i < originalSet.size(); i++)
////            for (int j = 0; j < originalSet.size() - i; j++) {
////                List<T> subList = originalList.subList(i, i + j + 1);
////                ComparableTreeSet<T> comparableTreeSet = new ComparableTreeSet<>();
////                comparableTreeSet.add((T) subList);
////                newSet.add((T) comparableTreeSet);
////            }
//
//        return Sets.powerSet(originalSet);

        Iterable<? extends Iterable<? extends E>> sets = Sets.powerSet(originalSet);

        List<E> lists = new ArrayList<>();
        for (Iterable set : sets) {
            Set<E> list = new ComparableTreeSet<>();
            list.addAll((Collection<? extends E>) set);
            lists.add((E) list);
        }

        Collections.sort(lists);

//        if (originalSet.isEmpty()) {
//            sets.add(new ComparableTreeSet<>());
//            return sets;
//        }
//        List<T> list = new ArrayList<T>(originalSet);
//        T head = list.get(0);
//        int end = list.size();
//        Set<T> rest = new TreeSet<T>(list.subList(1, end));
//        for (Iterable<? extends T> set : powerSet(rest)) {
//            Set<T> newSet = new ComparableTreeSet<>();
//            newSet.add(head);
//            newSet.addAll((Collection<? extends T>) set);
//            sets.add(newSet);
//            sets.add((Set<T>) set);
//            end--;
//        }


        return (Iterable<? extends Iterable<? extends E>>) lists;
//    }
    }

    public static <E extends Comparable> Iterable<? extends Iterable<? extends E>> powerSet(E... originalSet) {
        return powerSet(new TreeSet<>(Arrays.asList(originalSet)));
    }
}

