package rocks.zipcode.io.quiz4.objectorientation;

import rocks.zipcode.io.quiz4.fundamentals.StringEvaluator;

import java.util.ArrayList;
import java.util.List;

/**
 * @author leon on 11/12/2018.
 */
public class StringAssembler {

    ArrayList<String> strings;
    String delimiter;

    public StringAssembler(Character delimeter) {
        this.delimiter = "" + delimeter;
        this.strings = new ArrayList<>();
    }
;
    public StringAssembler append(String str) {
        strings.add(str);
        return this;
    }

    public String assemble() {
        return String.join(delimiter, strings);
    }

}
