package rocks.zipcode.io.quiz4.fundamentals;

import java.util.*;

/**
 * @author leon on 11/12/2018.
 */
public class StringEvaluator {
    public static String[] getAllPrefixes(String string) {
        LinkedHashSet<String> stringStack = new LinkedHashSet<>();
        for (int i = 0; i < string.length(); i++)
            for (int j = 0; j < string.length() - i; j++) {
                String substring = string.substring(i, i + j + 1);
                    stringStack.add(substring);
            }
        return stringStack.toArray(new String[0]);
    }

    public static String[] getCommonPrefixes(String string1, String string2) {
        List<String> result = new ArrayList<String>(Arrays.asList(getAllPrefixes(string1)));
        result.retainAll(Arrays.asList(getAllPrefixes(string2)));
        return result.toArray(new String[0]);
    }

    public static String getLargestCommonPrefix(String string1, String string2) {
        String[] commonArr = getCommonPrefixes(string1,string2);
        String longestString = "";
        for (String s : commonArr) {
            if (s.length() > longestString.length()) {
                longestString = s;
            }
        }
        return longestString;
    }
}
