package rocks.zipcode.io.quiz4.generics;

import java.util.Collection;
import java.util.Iterator;
import java.util.Stack;

/**
 * @author leon on 11/12/2018.
 */
public class MyStack<SomeType> implements Iterable<SomeType> {

    Stack<SomeType> someTypeStack = new Stack<>();

    public MyStack() { }

    public Boolean isEmpty() {
        return someTypeStack.isEmpty();
    }

    public void push(SomeType i) {
        someTypeStack.push(i);
    }

    public SomeType peek() {
        if (someTypeStack.isEmpty()) {
            return null;
        } else return someTypeStack.peek();
    }

    public SomeType pop() {
        return someTypeStack.pop();
    }

    @Override
    public Iterator<SomeType> iterator() {
        return null;
    }
}
